import java.io.*;
import java.util.*;


class DecComparator implements Comparator<Integer> {
    public int compare (Integer i1, Integer i2 ) {
        return Integer.compare(i1,i2);
    }
}

public class Main {

    static boolean isEasy(double num) {
        int d = 2;
        if ( num == 1 ) return false;
        double sq = Math.sqrt(num);
        while ( d <= sq ) {
            if ( num % d == 0 ) {
                return false;
            }
            d++;
        }
        return true;
    }

    static boolean check (int num, ArrayList<Integer> n) {
        int ind = -1;
        n.sort(new DecComparator());
        for (int i = n.size()-1; i >= 0; i--) {
            int a = n.get(i);
            if ( Math.max(num,a) % Math.min(num,a) == 0 ) {
                ind = i;
                break;
            }
        }
        if ( ind != -1 && isEasy((double)Math.max(num,n.get(ind))/Math.min(num,n.get(ind))) ) {
            return false;
        }
        return true;
    }


    public static void main(String[] args) throws IOException {

        int n = nextInt();
        int[] arr = new int[n];
        ArrayList<Integer> x = new ArrayList<>();
        ArrayList<Integer> y = new ArrayList<>();

        for (int i = 0; i < n; i++) {
            arr[i] = nextInt();
            if ( x.isEmpty() || check(arr[i], x) ) {
                x.add(arr[i]);
                arr[i] = 1;
            } else {
                y.add(arr[i]);
                arr[i] = 2;
            }
        }


        for(int s: arr) {
            out.print(s + " ");
        }


        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}