import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Main {

    static BigInteger count(long time, long[] a, long[] t ) {
        BigInteger cup = new BigInteger("0");
        BigInteger active = new BigInteger("0");
        for (int i = 1; i <= time; i++) {
            active = active.multiply(new BigInteger("2"));
            for (int j = 0; j < a.length; j++) {
                if ( i == a[j] + t[j] ) {
                    cup = cup.subtract(new BigInteger("1"));
                    active = active.add(new BigInteger("2"));
                }
                if ( i == a[j] ) {
                    cup = cup.add(new BigInteger("1"));
                }
            }
        }

        return active.add(cup);
    }

    public static void main(String[] args) throws IOException {

        int n = nextInt();
        long m = nextLong();

        long[] a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextLong();
        }

        long[] t = new long[n];
        for (int i = 0; i < n; i++) {
            t[i] = nextLong();
        }

        long l = 0;
        long r = 20000;
        while ( r-l > 1 ) {
            long mid = (r+l)/2;
            if ( count(mid, a, t).compareTo(new BigInteger("" + m)) >= 0 ) {
                r = mid;
            } else {
                l = mid;
            }
        }


        out.println(r);

//        13 124
//        5 6 8 8 1 6 4 6 4 7 10 3 9
//        5 2 10 5 2 1 1 4 8 3 4 1 9

        out.close();

    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}