import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Main {

    static BigInteger count(long time, long[] a, long[] t ) {
        BigInteger cnt = new BigInteger("0");
        for (int j = 0; j < a.length; j++) {
            long loc = 0;
            if ( time < a[j]+t[j] && time >= a[j] ) {
                loc++;
            } else if ( time >= a[j] + t[j] ) {
                long step = time - a[j] - t[j] + 1;
                long num = 1;
                for (int i = 0; i < step; i++) {
                    num *= 2;
                }
                loc+=num;
            }
            cnt = cnt.add(new BigInteger("" + loc));
        }

        return cnt;
    }

    public static void main(String[] args) throws IOException {

        int n = nextInt();
        long m = nextLong();

        long[] a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextLong();
        }

        long[] t = new long[n];
        for (int i = 0; i < n; i++) {
            t[i] = nextLong();
        }

        for (int i = 0; i < 1000000000; i++) {
            BigInteger res = count(i, a, t);
            if ( res.compareTo(new BigInteger("" + m)) == 1 ) {
                out.println(-1);
                break;
            } else if ( res.compareTo(new BigInteger("" + m)) == 0 ) {
                out.println(i);
                break;
            }
        }

//        13 124
//        5 6 8 8 1 6 4 6 4 7 10 3 9
//        5 2 10 5 2 1 1 4 8 3 4 1 9

        out.close();

    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}